/* launchbar.c generated by valac 0.56.17, the Vala compiler
 * generated from launchbar.vala, do not modify */

/*
 * vala-panel
 * Copyright (C) 2015 Konstantin Pugin <ria.freelander@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include "launchbar.h"
#include <gio/gio.h>
#include <glib-object.h>
#include "applet-widget.h"
#include "toplevel.h"
#include "applet-widget-api.h"
#include <gdk/gdk.h>
#include <stdio.h>
#include "constants.h"
#include <gio/gdesktopappinfo.h>
#include <glib/gstdio.h>
#include "misc.h"
#include "applet-info.h"

#define LAUNCH_BAR_BUTTONS "launch-buttons"
#define LAUNCH_BAR_BOOTSTRAP "launchbar-bootstrap"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	LAUNCH_BAR_BAR_0_PROPERTY,
	LAUNCH_BAR_BAR_NUM_PROPERTIES
};
static GParamSpec* launch_bar_bar_properties[LAUNCH_BAR_BAR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define LAUNCH_BAR_TYPE_BUTTON (launch_bar_button_get_type ())
#define LAUNCH_BAR_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LAUNCH_BAR_TYPE_BUTTON, LaunchBarButton))
#define LAUNCH_BAR_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LAUNCH_BAR_TYPE_BUTTON, LaunchBarButtonClass))
#define LAUNCH_BAR_IS_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LAUNCH_BAR_TYPE_BUTTON))
#define LAUNCH_BAR_IS_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LAUNCH_BAR_TYPE_BUTTON))
#define LAUNCH_BAR_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LAUNCH_BAR_TYPE_BUTTON, LaunchBarButtonClass))

typedef struct _LaunchBarButton LaunchBarButton;
typedef struct _LaunchBarButtonClass LaunchBarButtonClass;

struct _LaunchBarBarPrivate {
	GtkFlowBox* layout;
	gchar** prev_ids;
	gint prev_ids_length1;
	gint _prev_ids_size_;
	GAppInfoMonitor* app_monitor;
};

static gint LaunchBarBar_private_offset;
static gpointer launch_bar_bar_parent_class = NULL;
static GType launch_bar_bar_type_id = 0;

static void launch_bar_bar_real_constructed (GObject* base);
static void __lambda4_ (LaunchBarBar* self,
                 GObject* o,
                 GParamSpec* a);
static void ___lambda4__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static gboolean launch_bar_bar_drag_drop_cb (LaunchBarBar* self,
                                      GtkWidget* widget,
                                      GdkDragContext* context,
                                      gint x,
                                      gint y,
                                      guint time);
static gboolean _launch_bar_bar_drag_drop_cb_gtk_widget_drag_drop (GtkWidget* _sender,
                                                            GdkDragContext* context,
                                                            gint x,
                                                            gint y,
                                                            guint time_,
                                                            gpointer self);
static void launch_bar_bar_drag_data_received_cb (LaunchBarBar* self,
                                           GtkWidget* widget,
                                           GdkDragContext* context,
                                           gint x,
                                           gint y,
                                           GtkSelectionData* selection_data,
                                           guint target_type,
                                           guint time);
static void _launch_bar_bar_drag_data_received_cb_gtk_widget_drag_data_received (GtkWidget* _sender,
                                                                          GdkDragContext* context,
                                                                          gint x,
                                                                          gint y,
                                                                          GtkSelectionData* selection_data,
                                                                          guint info,
                                                                          guint time_,
                                                                          gpointer self);
static gint launch_bar_bar_launchbar_layout_sort_func (LaunchBarBar* self,
                                                GtkFlowBoxChild* a,
                                                GtkFlowBoxChild* b);
static gint _launch_bar_bar_launchbar_layout_sort_func_gtk_flow_box_sort_func (GtkFlowBoxChild* child1,
                                                                        GtkFlowBoxChild* child2,
                                                                        gpointer self);
static void launch_bar_bar_update_buttons_from_gsettings (LaunchBarBar* self);
static void _launch_bar_bar_update_buttons_from_gsettings_g_settings_changed (GSettings* _sender,
                                                                       const gchar* key,
                                                                       gpointer self);
static void _launch_bar_bar_update_buttons_from_gsettings_g_app_info_monitor_changed (GAppInfoMonitor* _sender,
                                                                               gpointer self);
static void __lambda12_ (LaunchBarBar* self,
                  GtkFlowBoxChild* ch);
GType launch_bar_button_register_type (GTypeModule * module);
VALA_EXTERN GType launch_bar_button_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void launch_bar_button_launch (LaunchBarButton* self);
static void ___lambda12__gtk_flow_box_child_activated (GtkFlowBox* _sender,
                                                GtkFlowBoxChild* child,
                                                gpointer self);
static GtkWidget* launch_bar_bar_real_get_settings_ui (ValaPanelApplet* base);
static void launch_bar_bar_load_buttons (LaunchBarBar* self,
                                  gchar** loaded_ids,
                                  gint loaded_ids_length1);
VALA_EXTERN void launch_bar_bar_request_remove_id (LaunchBarBar* self,
                                       const gchar* id);
static gchar** _vala_array_dup1 (gchar** self,
                          gssize length);
static gchar** launch_bar_bar_concat_strv_uniq (LaunchBarBar* self,
                                         gchar** arr1,
                                         gint arr1_length1,
                                         gchar** arr2,
                                         gint arr2_length1,
                                         gchar** arr3,
                                         gint arr3_length1,
                                         gint* result_length1);
VALA_EXTERN void launch_bar_bar_commit_ids (LaunchBarBar* self);
VALA_EXTERN void launch_bar_bar_undo_removal_request (LaunchBarBar* self);
static gchar** _vala_array_dup2 (gchar** self,
                          gssize length);
static gchar** _vala_array_dup3 (gchar** self,
                          gssize length);
static gchar** _vala_array_dup4 (gchar** self,
                          gssize length);
VALA_EXTERN const gchar* launch_bar_button_get_id (LaunchBarButton* self);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      gssize stack_length,
                                      const gchar* needle);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static LaunchBarButtonType launch_bar_bar_load_button_info (LaunchBarBar* self,
                                                     const gchar* str_pretend,
                                                     GAppInfo** info,
                                                     gchar** content_type);
VALA_EXTERN LaunchBarButton* launch_bar_button_new_with_content_type (GAppInfo* info,
                                                          const gchar* uri,
                                                          LaunchBarButtonType type,
                                                          const gchar* content_type);
VALA_EXTERN LaunchBarButton* launch_bar_button_construct_with_content_type (GType object_type,
                                                                GAppInfo* info,
                                                                const gchar* uri,
                                                                LaunchBarButtonType type,
                                                                const gchar* content_type);
VALA_EXTERN LaunchBarButton* launch_bar_button_new (GAppInfo* info,
                                        const gchar* uri,
                                        LaunchBarButtonType type);
VALA_EXTERN LaunchBarButton* launch_bar_button_construct (GType object_type,
                                              GAppInfo* info,
                                              const gchar* uri,
                                              LaunchBarButtonType type);
static gchar** _vala_array_dup5 (gchar** self,
                          gssize length);
static void _vala_array_add2 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add3 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
VALA_EXTERN GIcon* launch_bar_bar_get_icon_from_id (LaunchBarBar* self,
                                        const gchar* id);
VALA_EXTERN GIcon* launch_bar_button_get_icon (LaunchBarButton* self);
VALA_EXTERN gchar* launch_bar_bar_get_display_name_from_id (LaunchBarBar* self,
                                                const gchar* id);
VALA_EXTERN gchar* launch_bar_button_get_display_name (LaunchBarButton* self);
static void launch_bar_bar_finalize (GObject * obj);
GType launch_bar_button_register_type (GTypeModule * module);
GType launch_bar_config_widget_register_type (GTypeModule * module);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

const GtkTargetEntry MENU_TARGETS[2] = {{"text/uri-list", (guint) 0, (guint) 0}, {"application/x-desktop", (guint) 0, (guint) 0}};

static inline gpointer
launch_bar_bar_get_instance_private (LaunchBarBar* self)
{
	return G_STRUCT_MEMBER_P (self, LaunchBarBar_private_offset);
}

LaunchBarBar*
launch_bar_bar_construct (GType object_type,
                          ValaPanelToplevel* toplevel,
                          GSettings* settings,
                          const gchar* number)
{
	LaunchBarBar * self = NULL;
	g_return_val_if_fail (toplevel != NULL, NULL);
	g_return_val_if_fail (number != NULL, NULL);
	self = (LaunchBarBar*) vala_panel_applet_construct (object_type, toplevel, settings, number);
	return self;
}

LaunchBarBar*
launch_bar_bar_new (ValaPanelToplevel* toplevel,
                    GSettings* settings,
                    const gchar* number)
{
	return launch_bar_bar_construct (LAUNCH_BAR_TYPE_BAR, toplevel, settings, number);
}

static void
__lambda4_ (LaunchBarBar* self,
            GObject* o,
            GParamSpec* a)
{
	GtkOrientation _tmp0_ = 0;
	ValaPanelToplevel* _tmp1_;
	ValaPanelToplevel* _tmp2_;
	GtkOrientation _tmp3_;
	GtkOrientation _tmp4_;
	GtkFlowBox* _tmp5_;
	g_return_if_fail (o != NULL);
	g_return_if_fail (a != NULL);
	_tmp1_ = vala_panel_applet_get_toplevel ((ValaPanelApplet*) self);
	_tmp2_ = _tmp1_;
	g_object_get (_tmp2_, "orientation", &_tmp3_, NULL);
	_tmp4_ = _tmp3_;
	if (_tmp4_ == GTK_ORIENTATION_HORIZONTAL) {
		_tmp0_ = GTK_ORIENTATION_VERTICAL;
	} else {
		_tmp0_ = GTK_ORIENTATION_HORIZONTAL;
	}
	_tmp5_ = self->priv->layout;
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp5_, _tmp0_);
}

static void
___lambda4__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
	__lambda4_ ((LaunchBarBar*) self, _sender, pspec);
}

static gboolean
_launch_bar_bar_drag_drop_cb_gtk_widget_drag_drop (GtkWidget* _sender,
                                                   GdkDragContext* context,
                                                   gint x,
                                                   gint y,
                                                   guint time_,
                                                   gpointer self)
{
	gboolean result;
	result = launch_bar_bar_drag_drop_cb ((LaunchBarBar*) self, _sender, context, x, y, time_);
	return result;
}

static void
_launch_bar_bar_drag_data_received_cb_gtk_widget_drag_data_received (GtkWidget* _sender,
                                                                     GdkDragContext* context,
                                                                     gint x,
                                                                     gint y,
                                                                     GtkSelectionData* selection_data,
                                                                     guint info,
                                                                     guint time_,
                                                                     gpointer self)
{
	launch_bar_bar_drag_data_received_cb ((LaunchBarBar*) self, _sender, context, x, y, selection_data, info, time_);
}

static gint
_launch_bar_bar_launchbar_layout_sort_func_gtk_flow_box_sort_func (GtkFlowBoxChild* child1,
                                                                   GtkFlowBoxChild* child2,
                                                                   gpointer self)
{
	gint result;
	result = launch_bar_bar_launchbar_layout_sort_func ((LaunchBarBar*) self, child1, child2);
	return result;
}

static void
_launch_bar_bar_update_buttons_from_gsettings_g_settings_changed (GSettings* _sender,
                                                                  const gchar* key,
                                                                  gpointer self)
{
	launch_bar_bar_update_buttons_from_gsettings ((LaunchBarBar*) self);
}

static void
_launch_bar_bar_update_buttons_from_gsettings_g_app_info_monitor_changed (GAppInfoMonitor* _sender,
                                                                          gpointer self)
{
	launch_bar_bar_update_buttons_from_gsettings ((LaunchBarBar*) self);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
__lambda12_ (LaunchBarBar* self,
             GtkFlowBoxChild* ch)
{
	LaunchBarButton* lb = NULL;
	LaunchBarButton* _tmp0_;
	GtkFlowBox* _tmp1_;
	g_return_if_fail (ch != NULL);
	_tmp0_ = _g_object_ref0 (LAUNCH_BAR_IS_BUTTON (ch) ? ((LaunchBarButton*) ch) : NULL);
	lb = _tmp0_;
	launch_bar_button_launch (lb);
	_tmp1_ = self->priv->layout;
	gtk_flow_box_unselect_child (_tmp1_, (GtkFlowBoxChild*) lb);
	_g_object_unref0 (lb);
}

static void
___lambda12__gtk_flow_box_child_activated (GtkFlowBox* _sender,
                                           GtkFlowBoxChild* child,
                                           gpointer self)
{
	__lambda12_ ((LaunchBarBar*) self, child);
}

static void
launch_bar_bar_real_constructed (GObject* base)
{
	LaunchBarBar * self;
	GSimpleActionGroup* _tmp0_;
	GSimpleActionGroup* _tmp1_;
	GAction* _tmp2_;
	GtkFlowBox* _tmp3_;
	GtkFlowBox* _tmp4_;
	GtkOrientation _tmp5_ = 0;
	ValaPanelToplevel* _tmp6_;
	ValaPanelToplevel* _tmp7_;
	GtkOrientation _tmp8_;
	GtkOrientation _tmp9_;
	GtkFlowBox* _tmp10_;
	GtkFlowBox* _tmp11_;
	GtkFlowBox* _tmp12_;
	GtkFlowBox* _tmp13_;
	ValaPanelToplevel* _tmp14_;
	ValaPanelToplevel* _tmp15_;
	GtkFlowBox* _tmp16_;
	GtkFlowBox* _tmp17_;
	GtkFlowBox* _tmp18_;
	GSettings* _tmp19_;
	GSettings* _tmp20_;
	gchar* _tmp21_;
	GAppInfoMonitor* _tmp22_;
	GAppInfoMonitor* _tmp23_;
	GtkFlowBox* _tmp24_;
	GtkFlowBox* _tmp25_;
	self = (LaunchBarBar*) base;
	_tmp0_ = vala_panel_applet_get_action_group ((ValaPanelApplet*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_action_map_lookup_action ((GActionMap*) _tmp1_, VALA_PANEL_APPLET_ACTION_CONFIGURE);
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp2_) : NULL, TRUE);
	_tmp3_ = (GtkFlowBox*) gtk_flow_box_new ();
	g_object_ref_sink (_tmp3_);
	_g_object_unref0 (self->priv->layout);
	self->priv->layout = _tmp3_;
	_tmp4_ = self->priv->layout;
	gtk_drag_dest_set ((GtkWidget*) _tmp4_, GTK_DEST_DEFAULT_MOTION | GTK_DEST_DEFAULT_HIGHLIGHT, MENU_TARGETS, (gint) G_N_ELEMENTS (MENU_TARGETS), GDK_ACTION_COPY | GDK_ACTION_MOVE);
	_tmp6_ = vala_panel_applet_get_toplevel ((ValaPanelApplet*) self);
	_tmp7_ = _tmp6_;
	g_object_get (_tmp7_, "orientation", &_tmp8_, NULL);
	_tmp9_ = _tmp8_;
	if (_tmp9_ == GTK_ORIENTATION_HORIZONTAL) {
		_tmp5_ = GTK_ORIENTATION_VERTICAL;
	} else {
		_tmp5_ = GTK_ORIENTATION_HORIZONTAL;
	}
	_tmp10_ = self->priv->layout;
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp10_, _tmp5_);
	_tmp11_ = self->priv->layout;
	gtk_flow_box_set_activate_on_single_click (_tmp11_, TRUE);
	_tmp12_ = self->priv->layout;
	gtk_flow_box_set_selection_mode (_tmp12_, GTK_SELECTION_NONE);
	_tmp13_ = self->priv->layout;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp13_);
	_tmp14_ = vala_panel_applet_get_toplevel ((ValaPanelApplet*) self);
	_tmp15_ = _tmp14_;
	g_signal_connect_object ((GObject*) _tmp15_, "notify::panel-gravity", (GCallback) ___lambda4__g_object_notify, self, 0);
	_tmp16_ = self->priv->layout;
	g_signal_connect_object ((GtkWidget*) _tmp16_, "drag-drop", (GCallback) _launch_bar_bar_drag_drop_cb_gtk_widget_drag_drop, self, 0);
	_tmp17_ = self->priv->layout;
	g_signal_connect_object ((GtkWidget*) _tmp17_, "drag-data-received", (GCallback) _launch_bar_bar_drag_data_received_cb_gtk_widget_drag_data_received, self, 0);
	_tmp18_ = self->priv->layout;
	gtk_flow_box_set_sort_func (_tmp18_, _launch_bar_bar_launchbar_layout_sort_func_gtk_flow_box_sort_func, g_object_ref (self), g_object_unref);
	_tmp19_ = vala_panel_applet_get_settings ((ValaPanelApplet*) self);
	_tmp20_ = _tmp19_;
	_tmp21_ = g_strconcat ("changed::", LAUNCH_BAR_BUTTONS, NULL);
	g_signal_connect_object (_tmp20_, _tmp21_, (GCallback) _launch_bar_bar_update_buttons_from_gsettings_g_settings_changed, self, 0);
	_g_free0 (_tmp21_);
	_tmp22_ = g_app_info_monitor_get ();
	_g_object_unref0 (self->priv->app_monitor);
	self->priv->app_monitor = _tmp22_;
	_tmp23_ = self->priv->app_monitor;
	g_signal_connect_object (_tmp23_, "changed", (GCallback) _launch_bar_bar_update_buttons_from_gsettings_g_app_info_monitor_changed, self, 0);
	launch_bar_bar_update_buttons_from_gsettings (self);
	_tmp24_ = self->priv->layout;
	g_signal_connect_object (_tmp24_, "child-activated", (GCallback) ___lambda12__gtk_flow_box_child_activated, self, 0);
	_tmp25_ = self->priv->layout;
	gtk_widget_show ((GtkWidget*) _tmp25_);
	gtk_widget_show ((GtkWidget*) self);
}

static GtkWidget*
launch_bar_bar_real_get_settings_ui (ValaPanelApplet* base)
{
	LaunchBarBar * self;
	LaunchBarConfig* _tmp0_;
	GtkWidget* result;
	self = (LaunchBarBar*) base;
	_tmp0_ = launch_bar_config_widget_new (self);
	g_object_ref_sink (_tmp0_);
	result = (GtkWidget*) _tmp0_;
	return result;
}

static void
launch_bar_bar_update_buttons_from_gsettings (LaunchBarBar* self)
{
	gchar** loaded_ids = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint loaded_ids_length1;
	gint _loaded_ids_size_;
	g_return_if_fail (self != NULL);
	_tmp0_ = vala_panel_applet_get_settings ((ValaPanelApplet*) self);
	_tmp1_ = _tmp0_;
	_tmp3_ = _tmp2_ = g_settings_get_strv (_tmp1_, LAUNCH_BAR_BUTTONS);
	loaded_ids = _tmp3_;
	loaded_ids_length1 = _vala_array_length (_tmp2_);
	_loaded_ids_size_ = loaded_ids_length1;
	launch_bar_bar_load_buttons (self, loaded_ids, (gint) loaded_ids_length1);
	loaded_ids = (_vala_array_free (loaded_ids, loaded_ids_length1, (GDestroyNotify) g_free), NULL);
}

static gchar**
_vala_array_dup1 (gchar** self,
                  gssize length)
{
	if (length >= 0) {
		gchar** result;
		gssize i;
		result = g_new0 (gchar*, length + 1);
		for (i = 0; i < length; i++) {
			gchar* _tmp0_;
			_tmp0_ = g_strdup (self[i]);
			result[i] = _tmp0_;
		}
		return result;
	}
	return NULL;
}

void
launch_bar_bar_request_remove_id (LaunchBarBar* self,
                                  const gchar* id)
{
	gint idx = 0;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gchar** _tmp7_;
	gint _tmp7__length1;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gchar** _tmp9_;
	gint _tmp9__length1;
	gint _tmp10_ = 0;
	gchar** _tmp11_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (id != NULL);
	{
		gboolean _tmp0_ = FALSE;
		idx = 0;
		_tmp0_ = TRUE;
		while (TRUE) {
			gchar** _tmp2_;
			gint _tmp2__length1;
			gchar** _tmp3_;
			gint _tmp3__length1;
			const gchar* _tmp4_;
			if (!_tmp0_) {
				gint _tmp1_;
				_tmp1_ = idx;
				idx = _tmp1_ + 1;
			}
			_tmp0_ = FALSE;
			_tmp2_ = self->ids;
			_tmp2__length1 = self->ids_length1;
			if (!(idx < _tmp2__length1)) {
				break;
			}
			_tmp3_ = self->ids;
			_tmp3__length1 = self->ids_length1;
			_tmp4_ = _tmp3_[idx];
			if (g_strcmp0 (_tmp4_, id) == 0) {
				break;
			}
		}
	}
	_tmp5_ = self->ids;
	_tmp5__length1 = self->ids_length1;
	_tmp6_ = (_tmp5_ != NULL) ? _vala_array_dup1 (_tmp5_, _tmp5__length1) : _tmp5_;
	_tmp6__length1 = _tmp5__length1;
	self->priv->prev_ids = (_vala_array_free (self->priv->prev_ids, self->priv->prev_ids_length1, (GDestroyNotify) g_free), NULL);
	self->priv->prev_ids = _tmp6_;
	self->priv->prev_ids_length1 = _tmp6__length1;
	self->priv->_prev_ids_size_ = self->priv->prev_ids_length1;
	_tmp7_ = self->ids;
	_tmp7__length1 = self->ids_length1;
	_tmp8_ = self->ids;
	_tmp8__length1 = self->ids_length1;
	_tmp9_ = self->ids;
	_tmp9__length1 = self->ids_length1;
	_tmp11_ = launch_bar_bar_concat_strv_uniq (self, _tmp7_ + 0, (gint) (idx - 0), _tmp8_ + (idx + 1), (gint) (_tmp9__length1 - (idx + 1)), NULL, (gint) 0, &_tmp10_);
	self->ids = (_vala_array_free (self->ids, self->ids_length1, (GDestroyNotify) g_free), NULL);
	self->ids = _tmp11_;
	self->ids_length1 = _tmp10_;
	self->_ids_size_ = self->ids_length1;
}

void
launch_bar_bar_commit_ids (LaunchBarBar* self)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	g_return_if_fail (self != NULL);
	_tmp0_ = vala_panel_applet_get_settings ((ValaPanelApplet*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = self->ids;
	_tmp2__length1 = self->ids_length1;
	g_settings_set_strv (_tmp1_, LAUNCH_BAR_BUTTONS, _tmp2_);
}

static gchar**
_vala_array_dup2 (gchar** self,
                  gssize length)
{
	if (length >= 0) {
		gchar** result;
		gssize i;
		result = g_new0 (gchar*, length + 1);
		for (i = 0; i < length; i++) {
			gchar* _tmp0_;
			_tmp0_ = g_strdup (self[i]);
			result[i] = _tmp0_;
		}
		return result;
	}
	return NULL;
}

void
launch_bar_bar_undo_removal_request (LaunchBarBar* self)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->prev_ids;
	_tmp0__length1 = self->priv->prev_ids_length1;
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup2 (_tmp0_, _tmp0__length1) : _tmp0_;
	_tmp1__length1 = _tmp0__length1;
	self->ids = (_vala_array_free (self->ids, self->ids_length1, (GDestroyNotify) g_free), NULL);
	self->ids = _tmp1_;
	self->ids_length1 = _tmp1__length1;
	self->_ids_size_ = self->ids_length1;
	self->priv->prev_ids = (_vala_array_free (self->priv->prev_ids, self->priv->prev_ids_length1, (GDestroyNotify) g_free), NULL);
	self->priv->prev_ids = NULL;
	self->priv->prev_ids_length1 = 0;
	self->priv->_prev_ids_size_ = self->priv->prev_ids_length1;
}

static gboolean
launch_bar_bar_drag_drop_cb (LaunchBarBar* self,
                             GtkWidget* widget,
                             GdkDragContext* context,
                             gint x,
                             gint y,
                             guint time)
{
	gboolean is_valid_drop_site = FALSE;
	GList* _tmp0_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	g_return_val_if_fail (context != NULL, FALSE);
	is_valid_drop_site = TRUE;
	_tmp0_ = gdk_drag_context_list_targets (context);
	if (_tmp0_ != NULL) {
		GdkAtom target_type = (GdkAtom) 0U;
		GList* _tmp1_;
		gconstpointer _tmp2_;
		_tmp1_ = gdk_drag_context_list_targets (context);
		_tmp2_ = g_list_nth_data (_tmp1_, (guint) 0);
		target_type = (GdkAtom) ((GdkAtom) ((guintptr) _tmp2_));
		gtk_drag_get_data (widget, context, target_type, (guint32) time);
	} else {
		is_valid_drop_site = FALSE;
	}
	result = is_valid_drop_site;
	return result;
}

static void
launch_bar_bar_drag_data_received_cb (LaunchBarBar* self,
                                      GtkWidget* widget,
                                      GdkDragContext* context,
                                      gint x,
                                      gint y,
                                      GtkSelectionData* selection_data,
                                      guint target_type,
                                      guint time)
{
	gboolean delete_selection_data = FALSE;
	gboolean dnd_success = FALSE;
	gint index = 0;
	GdkRectangle r = {0};
	GdkRectangle _tmp0_ = {0};
	GtkFlowBox* flowbox = NULL;
	GtkFlowBox* _tmp1_;
	GtkFlowBox* _tmp2_;
	GList* _tmp3_;
	gboolean _tmp7_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	g_return_if_fail (context != NULL);
	g_return_if_fail (selection_data != NULL);
	delete_selection_data = FALSE;
	dnd_success = FALSE;
	index = 0;
	_tmp0_.x = x;
	_tmp0_.y = y;
	_tmp0_.width = 1;
	_tmp0_.height = 1;
	r = _tmp0_;
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (widget, gtk_flow_box_get_type ()) ? ((GtkFlowBox*) widget) : NULL);
	flowbox = _tmp1_;
	_tmp2_ = flowbox;
	_tmp3_ = gtk_container_get_children ((GtkContainer*) _tmp2_);
	{
		GList* w_collection = NULL;
		GList* w_it = NULL;
		w_collection = _tmp3_;
		for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
			GtkWidget* w = NULL;
			w = (GtkWidget*) w_it->data;
			{
				GtkWidget* _tmp4_;
				GdkRectangle _tmp5_;
				gint _tmp6_;
				_tmp4_ = w;
				_tmp5_ = r;
				if (gtk_widget_intersect (_tmp4_, &_tmp5_, NULL)) {
					break;
				}
				_tmp6_ = index;
				index = _tmp6_ + 1;
			}
		}
		(w_collection == NULL) ? NULL : (w_collection = (g_list_free (w_collection), NULL));
	}
	if (gdk_drag_context_get_suggested_action (context) == GDK_ACTION_MOVE) {
		delete_selection_data = TRUE;
	}
	if (selection_data != NULL) {
		_tmp7_ = gtk_selection_data_get_length (selection_data) >= 0;
	} else {
		_tmp7_ = FALSE;
	}
	if (_tmp7_) {
		gchar** new_ids = NULL;
		gint new_ids_length1;
		gint _new_ids_size_;
		gchar** loaded_ids = NULL;
		gchar** _tmp8_;
		gchar** _tmp9_;
		gint loaded_ids_length1;
		gint _loaded_ids_size_;
		GSettings* _tmp20_;
		GSettings* _tmp21_;
		gchar** _tmp22_;
		gint _tmp22__length1;
		new_ids = NULL;
		new_ids_length1 = 0;
		_new_ids_size_ = new_ids_length1;
		_tmp9_ = _tmp8_ = gtk_selection_data_get_uris (selection_data);
		loaded_ids = _tmp9_;
		loaded_ids_length1 = _vala_array_length (_tmp8_);
		_loaded_ids_size_ = loaded_ids_length1;
		if (index >= 0) {
			gchar** _tmp10_;
			gint _tmp10__length1;
			gchar** _tmp11_;
			gint _tmp11__length1;
			gchar** _tmp12_;
			gint _tmp12__length1;
			gchar** _tmp13_;
			gint _tmp13__length1;
			gint _tmp14_ = 0;
			gchar** _tmp15_;
			_tmp10_ = self->ids;
			_tmp10__length1 = self->ids_length1;
			_tmp11_ = loaded_ids;
			_tmp11__length1 = loaded_ids_length1;
			_tmp12_ = self->ids;
			_tmp12__length1 = self->ids_length1;
			_tmp13_ = self->ids;
			_tmp13__length1 = self->ids_length1;
			_tmp15_ = launch_bar_bar_concat_strv_uniq (self, _tmp10_ + 0, (gint) (index - 0), _tmp11_, (gint) _tmp11__length1, _tmp12_ + index, (gint) (_tmp13__length1 - index), &_tmp14_);
			new_ids = (_vala_array_free (new_ids, new_ids_length1, (GDestroyNotify) g_free), NULL);
			new_ids = _tmp15_;
			new_ids_length1 = _tmp14_;
			_new_ids_size_ = new_ids_length1;
		} else {
			gchar** _tmp16_;
			gint _tmp16__length1;
			gchar** _tmp17_;
			gint _tmp17__length1;
			gint _tmp18_ = 0;
			gchar** _tmp19_;
			_tmp16_ = loaded_ids;
			_tmp16__length1 = loaded_ids_length1;
			_tmp17_ = self->ids;
			_tmp17__length1 = self->ids_length1;
			_tmp19_ = launch_bar_bar_concat_strv_uniq (self, _tmp16_, (gint) _tmp16__length1, _tmp17_, (gint) _tmp17__length1, NULL, (gint) 0, &_tmp18_);
			new_ids = (_vala_array_free (new_ids, new_ids_length1, (GDestroyNotify) g_free), NULL);
			new_ids = _tmp19_;
			new_ids_length1 = _tmp18_;
			_new_ids_size_ = new_ids_length1;
		}
		_tmp20_ = vala_panel_applet_get_settings ((ValaPanelApplet*) self);
		_tmp21_ = _tmp20_;
		_tmp22_ = new_ids;
		_tmp22__length1 = new_ids_length1;
		g_settings_set_strv (_tmp21_, LAUNCH_BAR_BUTTONS, _tmp22_);
		dnd_success = TRUE;
		loaded_ids = (_vala_array_free (loaded_ids, loaded_ids_length1, (GDestroyNotify) g_free), NULL);
		new_ids = (_vala_array_free (new_ids, new_ids_length1, (GDestroyNotify) g_free), NULL);
	}
	if (dnd_success == FALSE) {
		FILE* _tmp23_;
		_tmp23_ = stderr;
		fprintf (_tmp23_, "Invalid DnD data.\n");
	}
	gtk_drag_finish (context, dnd_success, delete_selection_data, (guint32) time);
	_g_object_unref0 (flowbox);
}

static gchar**
_vala_array_dup3 (gchar** self,
                  gssize length)
{
	if (length >= 0) {
		gchar** result;
		gssize i;
		result = g_new0 (gchar*, length + 1);
		for (i = 0; i < length; i++) {
			gchar* _tmp0_;
			_tmp0_ = g_strdup (self[i]);
			result[i] = _tmp0_;
		}
		return result;
	}
	return NULL;
}

static gchar**
_vala_array_dup4 (gchar** self,
                  gssize length)
{
	if (length >= 0) {
		gchar** result;
		gssize i;
		result = g_new0 (gchar*, length + 1);
		for (i = 0; i < length; i++) {
			gchar* _tmp0_;
			_tmp0_ = g_strdup (self[i]);
			result[i] = _tmp0_;
		}
		return result;
	}
	return NULL;
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             gssize stack_length,
                             const gchar* needle)
{
	gssize i;
	for (i = 0; i < stack_length; i++) {
		if (g_strcmp0 (stack[i], needle) == 0) {
			return TRUE;
		}
	}
	return FALSE;
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
launch_bar_bar_load_buttons (LaunchBarBar* self,
                             gchar** loaded_ids,
                             gint loaded_ids_length1)
{
	gchar** widget_ids = NULL;
	gchar** _tmp0_;
	gint widget_ids_length1;
	gint _widget_ids_size_;
	gchar** _tmp1_;
	gint _tmp1__length1;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar** _tmp3_;
	gint _tmp3__length1;
	GtkFlowBox* _tmp4_;
	GList* _tmp5_;
	gchar** _tmp18_;
	gint _tmp18__length1;
	GtkFlowBox* _tmp40_;
	gchar** _tmp41_;
	gint _tmp41__length1;
	GtkFlowBox* _tmp49_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_new0 (gchar*, 0 + 1);
	widget_ids = _tmp0_;
	widget_ids_length1 = 0;
	_widget_ids_size_ = widget_ids_length1;
	_tmp1_ = self->ids;
	_tmp1__length1 = self->ids_length1;
	_tmp2_ = (_tmp1_ != NULL) ? _vala_array_dup3 (_tmp1_, _tmp1__length1) : _tmp1_;
	_tmp2__length1 = _tmp1__length1;
	self->priv->prev_ids = (_vala_array_free (self->priv->prev_ids, self->priv->prev_ids_length1, (GDestroyNotify) g_free), NULL);
	self->priv->prev_ids = _tmp2_;
	self->priv->prev_ids_length1 = _tmp2__length1;
	self->priv->_prev_ids_size_ = self->priv->prev_ids_length1;
	_tmp3_ = (loaded_ids != NULL) ? _vala_array_dup4 (loaded_ids, loaded_ids_length1) : loaded_ids;
	_tmp3__length1 = loaded_ids_length1;
	self->ids = (_vala_array_free (self->ids, self->ids_length1, (GDestroyNotify) g_free), NULL);
	self->ids = _tmp3_;
	self->ids_length1 = _tmp3__length1;
	self->_ids_size_ = self->ids_length1;
	_tmp4_ = self->priv->layout;
	_tmp5_ = gtk_container_get_children ((GtkContainer*) _tmp4_);
	{
		GList* w_collection = NULL;
		GList* w_it = NULL;
		w_collection = _tmp5_;
		for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
			GtkWidget* w = NULL;
			w = (GtkWidget*) w_it->data;
			{
				LaunchBarButton* lb = NULL;
				GtkWidget* _tmp6_;
				LaunchBarButton* _tmp7_;
				LaunchBarButton* _tmp8_;
				const gchar* _tmp9_;
				const gchar* _tmp10_;
				gchar** _tmp11_;
				gint _tmp11__length1;
				_tmp6_ = w;
				_tmp7_ = _g_object_ref0 (LAUNCH_BAR_IS_BUTTON (_tmp6_) ? ((LaunchBarButton*) _tmp6_) : NULL);
				lb = _tmp7_;
				_tmp8_ = lb;
				_tmp9_ = launch_bar_button_get_id (_tmp8_);
				_tmp10_ = _tmp9_;
				_tmp11_ = self->ids;
				_tmp11__length1 = self->ids_length1;
				if (!_vala_string_array_contains (_tmp11_, _tmp11__length1, _tmp10_)) {
					GtkFlowBox* _tmp12_;
					GtkWidget* _tmp13_;
					_tmp12_ = self->priv->layout;
					_tmp13_ = w;
					gtk_container_remove ((GtkContainer*) _tmp12_, _tmp13_);
				} else {
					LaunchBarButton* _tmp14_;
					const gchar* _tmp15_;
					const gchar* _tmp16_;
					gchar* _tmp17_;
					_tmp14_ = lb;
					_tmp15_ = launch_bar_button_get_id (_tmp14_);
					_tmp16_ = _tmp15_;
					_tmp17_ = g_strdup (_tmp16_);
					_vala_array_add1 (&widget_ids, &widget_ids_length1, &_widget_ids_size_, _tmp17_);
				}
				_g_object_unref0 (lb);
			}
		}
		(w_collection == NULL) ? NULL : (w_collection = (g_list_free (w_collection), NULL));
	}
	_tmp18_ = self->ids;
	_tmp18__length1 = self->ids_length1;
	{
		gchar** id_collection = NULL;
		gint id_collection_length1 = 0;
		gint _id_collection_size_ = 0;
		gint id_it = 0;
		id_collection = _tmp18_;
		id_collection_length1 = _tmp18__length1;
		for (id_it = 0; id_it < id_collection_length1; id_it = id_it + 1) {
			gchar* _tmp19_;
			gchar* id = NULL;
			_tmp19_ = g_strdup (id_collection[id_it]);
			id = _tmp19_;
			{
				const gchar* _tmp20_;
				gchar** _tmp21_;
				gint _tmp21__length1;
				_tmp20_ = id;
				_tmp21_ = widget_ids;
				_tmp21__length1 = widget_ids_length1;
				if (!_vala_string_array_contains (_tmp21_, _tmp21__length1, _tmp20_)) {
					GAppInfo* info = NULL;
					gchar* content_type = NULL;
					LaunchBarButtonType type = 0;
					const gchar* _tmp22_;
					GAppInfo* _tmp23_ = NULL;
					gchar* _tmp24_ = NULL;
					LaunchBarButtonType _tmp25_;
					_tmp22_ = id;
					_tmp25_ = launch_bar_bar_load_button_info (self, _tmp22_, &_tmp23_, &_tmp24_);
					_g_object_unref0 (info);
					info = _tmp23_;
					_g_free0 (content_type);
					content_type = _tmp24_;
					type = _tmp25_;
					if (type != LAUNCH_BAR_BUTTON_TYPE_NONE) {
						LaunchBarButton* btn = NULL;
						const gchar* _tmp26_;
						ValaPanelToplevel* _tmp34_;
						ValaPanelToplevel* _tmp35_;
						LaunchBarButton* _tmp36_;
						GtkFlowBox* _tmp37_;
						LaunchBarButton* _tmp38_;
						LaunchBarButton* _tmp39_;
						btn = NULL;
						_tmp26_ = content_type;
						if (_tmp26_ != NULL) {
							GAppInfo* _tmp27_;
							const gchar* _tmp28_;
							const gchar* _tmp29_;
							LaunchBarButton* _tmp30_;
							_tmp27_ = info;
							_tmp28_ = id;
							_tmp29_ = content_type;
							_tmp30_ = launch_bar_button_new_with_content_type (_tmp27_, _tmp28_, type, _tmp29_);
							g_object_ref_sink (_tmp30_);
							_g_object_unref0 (btn);
							btn = _tmp30_;
						} else {
							GAppInfo* _tmp31_;
							const gchar* _tmp32_;
							LaunchBarButton* _tmp33_;
							_tmp31_ = info;
							_tmp32_ = id;
							_tmp33_ = launch_bar_button_new (_tmp31_, _tmp32_, type);
							g_object_ref_sink (_tmp33_);
							_g_object_unref0 (btn);
							btn = _tmp33_;
						}
						_tmp34_ = vala_panel_applet_get_toplevel ((ValaPanelApplet*) self);
						_tmp35_ = _tmp34_;
						_tmp36_ = btn;
						g_object_bind_property_with_closures ((GObject*) _tmp35_, VP_KEY_ICON_SIZE, (GObject*) _tmp36_, "icon-size", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
						_tmp37_ = self->priv->layout;
						_tmp38_ = btn;
						gtk_container_add ((GtkContainer*) _tmp37_, (GtkWidget*) _tmp38_);
						_tmp39_ = btn;
						gtk_widget_show ((GtkWidget*) _tmp39_);
						_g_object_unref0 (btn);
					}
					_g_free0 (content_type);
					_g_object_unref0 (info);
				}
				_g_free0 (id);
			}
		}
	}
	_tmp40_ = self->priv->layout;
	gtk_flow_box_invalidate_sort (_tmp40_);
	_tmp41_ = self->ids;
	_tmp41__length1 = self->ids_length1;
	if (_tmp41__length1 == 0) {
		LaunchBarButton* btn = NULL;
		LaunchBarButton* _tmp42_;
		ValaPanelToplevel* _tmp43_;
		ValaPanelToplevel* _tmp44_;
		LaunchBarButton* _tmp45_;
		GtkFlowBox* _tmp46_;
		LaunchBarButton* _tmp47_;
		LaunchBarButton* _tmp48_;
		_tmp42_ = launch_bar_button_new (NULL, NULL, LAUNCH_BAR_BUTTON_TYPE_BOOTSTRAP);
		g_object_ref_sink (_tmp42_);
		btn = _tmp42_;
		_tmp43_ = vala_panel_applet_get_toplevel ((ValaPanelApplet*) self);
		_tmp44_ = _tmp43_;
		_tmp45_ = btn;
		g_object_bind_property_with_closures ((GObject*) _tmp44_, VP_KEY_ICON_SIZE, (GObject*) _tmp45_, "icon-size", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
		_tmp46_ = self->priv->layout;
		_tmp47_ = btn;
		gtk_container_add ((GtkContainer*) _tmp46_, (GtkWidget*) _tmp47_);
		_tmp48_ = btn;
		gtk_widget_show ((GtkWidget*) _tmp48_);
		_g_object_unref0 (btn);
	}
	_tmp49_ = self->priv->layout;
	gtk_widget_show ((GtkWidget*) _tmp49_);
	widget_ids = (_vala_array_free (widget_ids, widget_ids_length1, (GDestroyNotify) g_free), NULL);
}

static LaunchBarButtonType
launch_bar_bar_load_button_info (LaunchBarBar* self,
                                 const gchar* str_pretend,
                                 GAppInfo** info,
                                 gchar** content_type)
{
	GAppInfo* _vala_info = NULL;
	gchar* _vala_content_type = NULL;
	GDesktopAppInfo* _tmp0_;
	GAppInfo* _tmp1_;
	GAppInfo* _tmp2_;
	GError* _inner_error0_ = NULL;
	LaunchBarButtonType result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (str_pretend != NULL, 0);
	_g_object_unref0 (_vala_info);
	_vala_info = NULL;
	_g_free0 (_vala_content_type);
	_vala_content_type = NULL;
	if (g_strcmp0 (str_pretend, LAUNCH_BAR_BOOTSTRAP) == 0) {
		result = LAUNCH_BAR_BUTTON_TYPE_BOOTSTRAP;
		if (info) {
			*info = _vala_info;
		} else {
			_g_object_unref0 (_vala_info);
		}
		if (content_type) {
			*content_type = _vala_content_type;
		} else {
			_g_free0 (_vala_content_type);
		}
		return result;
	}
	_tmp0_ = g_desktop_app_info_new (str_pretend);
	_tmp1_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, g_app_info_get_type ()) ? ((GAppInfo*) _tmp0_) : NULL;
	if (_tmp1_ == NULL) {
		_g_object_unref0 (_tmp0_);
	}
	_g_object_unref0 (_vala_info);
	_vala_info = _tmp1_;
	_tmp2_ = _vala_info;
	if (_tmp2_ != NULL) {
		result = LAUNCH_BAR_BUTTON_TYPE_DESKTOP;
		if (info) {
			*info = _vala_info;
		} else {
			_g_object_unref0 (_vala_info);
		}
		if (content_type) {
			*content_type = _vala_content_type;
		} else {
			_g_free0 (_vala_content_type);
		}
		return result;
	}
	{
		gchar* filename = NULL;
		gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		const gchar* _tmp6_;
		_tmp3_ = g_filename_from_uri (str_pretend, NULL, &_inner_error0_);
		filename = _tmp3_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp4_ = filename;
		_tmp5_ = g_content_type_guess (_tmp4_, NULL, (gsize) 0, NULL);
		_g_free0 (_vala_content_type);
		_vala_content_type = _tmp5_;
		_tmp6_ = _vala_content_type;
		if (g_strcmp0 (_tmp6_, "application/x-desktop") == 0) {
			const gchar* _tmp7_;
			GDesktopAppInfo* _tmp8_;
			GAppInfo* _tmp9_;
			GAppInfo* _tmp10_;
			_tmp7_ = filename;
			_tmp8_ = g_desktop_app_info_new_from_filename (_tmp7_);
			_tmp9_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp8_, g_app_info_get_type ()) ? ((GAppInfo*) _tmp8_) : NULL;
			if (_tmp9_ == NULL) {
				_g_object_unref0 (_tmp8_);
			}
			_g_object_unref0 (_vala_info);
			_vala_info = _tmp9_;
			_tmp10_ = _vala_info;
			if (_tmp10_ != NULL) {
				result = LAUNCH_BAR_BUTTON_TYPE_DESKTOP;
				_g_free0 (filename);
				if (info) {
					*info = _vala_info;
				} else {
					_g_object_unref0 (_vala_info);
				}
				if (content_type) {
					*content_type = _vala_content_type;
				} else {
					_g_free0 (_vala_content_type);
				}
				return result;
			}
			result = LAUNCH_BAR_BUTTON_TYPE_NONE;
			_g_free0 (filename);
			if (info) {
				*info = _vala_info;
			} else {
				_g_object_unref0 (_vala_info);
			}
			if (content_type) {
				*content_type = _vala_content_type;
			} else {
				_g_free0 (_vala_content_type);
			}
			return result;
		} else {
			gboolean _tmp11_ = FALSE;
			const gchar* _tmp12_;
			_tmp12_ = filename;
			if (g_file_test (_tmp12_, G_FILE_TEST_IS_EXECUTABLE)) {
				const gchar* _tmp13_;
				_tmp13_ = filename;
				_tmp11_ = !g_file_test (_tmp13_, G_FILE_TEST_IS_DIR);
			} else {
				_tmp11_ = FALSE;
			}
			if (_tmp11_) {
				GAppInfo* _tmp14_ = NULL;
				const gchar* _tmp15_;
				GAppInfo* _tmp16_;
				GAppInfo* _tmp17_;
				_tmp15_ = filename;
				_tmp16_ = g_app_info_create_from_commandline (_tmp15_, NULL, 0, &_inner_error0_);
				_tmp14_ = _tmp16_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_free0 (filename);
					goto __catch0_g_error;
				}
				_tmp17_ = _tmp14_;
				_tmp14_ = NULL;
				_g_object_unref0 (_vala_info);
				_vala_info = _tmp17_;
				result = LAUNCH_BAR_BUTTON_TYPE_EXECUTABLE;
				_g_object_unref0 (_tmp14_);
				_g_free0 (filename);
				if (info) {
					*info = _vala_info;
				} else {
					_g_object_unref0 (_vala_info);
				}
				if (content_type) {
					*content_type = _vala_content_type;
				} else {
					_g_free0 (_vala_content_type);
				}
				return result;
			} else {
				GAppInfo* _tmp18_;
				GAppInfo* _tmp19_;
				_tmp18_ = vala_panel_get_default_for_uri (str_pretend);
				_g_object_unref0 (_vala_info);
				_vala_info = _tmp18_;
				_tmp19_ = _vala_info;
				if (_tmp19_ != NULL) {
					result = LAUNCH_BAR_BUTTON_TYPE_URI;
					_g_free0 (filename);
					if (info) {
						*info = _vala_info;
					} else {
						_g_object_unref0 (_vala_info);
					}
					if (content_type) {
						*content_type = _vala_content_type;
					} else {
						_g_free0 (_vala_content_type);
					}
					return result;
				}
				result = LAUNCH_BAR_BUTTON_TYPE_NONE;
				_g_free0 (filename);
				if (info) {
					*info = _vala_info;
				} else {
					_g_object_unref0 (_vala_info);
				}
				if (content_type) {
					*content_type = _vala_content_type;
				} else {
					_g_free0 (_vala_content_type);
				}
				return result;
			}
		}
		_g_free0 (filename);
	}
	goto __finally0;
	__catch0_g_error:
	{
		g_clear_error (&_inner_error0_);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (_vala_info);
		_g_free0 (_vala_content_type);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return 0;
	}
	result = LAUNCH_BAR_BUTTON_TYPE_NONE;
	if (info) {
		*info = _vala_info;
	} else {
		_g_object_unref0 (_vala_info);
	}
	if (content_type) {
		*content_type = _vala_content_type;
	} else {
		_g_free0 (_vala_content_type);
	}
	return result;
}

static gint
launch_bar_bar_launchbar_layout_sort_func (LaunchBarBar* self,
                                           GtkFlowBoxChild* a,
                                           GtkFlowBoxChild* b)
{
	LaunchBarButton* lb_1 = NULL;
	LaunchBarButton* _tmp0_;
	LaunchBarButton* lb_2 = NULL;
	LaunchBarButton* _tmp1_;
	gint inta = 0;
	gint intb = 0;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (a != NULL, 0);
	g_return_val_if_fail (b != NULL, 0);
	_tmp0_ = _g_object_ref0 (LAUNCH_BAR_IS_BUTTON (a) ? ((LaunchBarButton*) a) : NULL);
	lb_1 = _tmp0_;
	_tmp1_ = _g_object_ref0 (LAUNCH_BAR_IS_BUTTON (b) ? ((LaunchBarButton*) b) : NULL);
	lb_2 = _tmp1_;
	inta = -1;
	intb = -1;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				gchar** _tmp4_;
				gint _tmp4__length1;
				LaunchBarButton* _tmp5_;
				const gchar* _tmp6_;
				const gchar* _tmp7_;
				gchar** _tmp8_;
				gint _tmp8__length1;
				const gchar* _tmp9_;
				LaunchBarButton* _tmp10_;
				const gchar* _tmp11_;
				const gchar* _tmp12_;
				gchar** _tmp13_;
				gint _tmp13__length1;
				const gchar* _tmp14_;
				if (!_tmp2_) {
					gint _tmp3_;
					_tmp3_ = i;
					i = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				_tmp4_ = self->ids;
				_tmp4__length1 = self->ids_length1;
				if (!(i < _tmp4__length1)) {
					break;
				}
				_tmp5_ = lb_1;
				_tmp6_ = launch_bar_button_get_id (_tmp5_);
				_tmp7_ = _tmp6_;
				_tmp8_ = self->ids;
				_tmp8__length1 = self->ids_length1;
				_tmp9_ = _tmp8_[i];
				if (g_strcmp0 (_tmp7_, _tmp9_) == 0) {
					inta = i;
				}
				_tmp10_ = lb_2;
				_tmp11_ = launch_bar_button_get_id (_tmp10_);
				_tmp12_ = _tmp11_;
				_tmp13_ = self->ids;
				_tmp13__length1 = self->ids_length1;
				_tmp14_ = _tmp13_[i];
				if (g_strcmp0 (_tmp12_, _tmp14_) == 0) {
					intb = i;
				}
			}
		}
	}
	result = inta - intb;
	_g_object_unref0 (lb_2);
	_g_object_unref0 (lb_1);
	return result;
}

static gchar**
_vala_array_dup5 (gchar** self,
                  gssize length)
{
	if (length >= 0) {
		gchar** result;
		gssize i;
		result = g_new0 (gchar*, length + 1);
		for (i = 0; i < length; i++) {
			gchar* _tmp0_;
			_tmp0_ = g_strdup (self[i]);
			result[i] = _tmp0_;
		}
		return result;
	}
	return NULL;
}

static void
_vala_array_add2 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add3 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static gchar**
launch_bar_bar_concat_strv_uniq (LaunchBarBar* self,
                                 gchar** arr1,
                                 gint arr1_length1,
                                 gchar** arr2,
                                 gint arr2_length1,
                                 gchar** arr3,
                                 gint arr3_length1,
                                 gint* result_length1)
{
	gchar** res = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gint res_length1;
	gint _res_size_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	gchar** result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = (arr1 != NULL) ? _vala_array_dup5 (arr1, arr1_length1) : arr1;
	_tmp0__length1 = arr1_length1;
	res = _tmp0_;
	res_length1 = _tmp0__length1;
	_res_size_ = res_length1;
	if (arr2 != NULL) {
		{
			gchar** s_collection = NULL;
			gint s_collection_length1 = 0;
			gint _s_collection_size_ = 0;
			gint s_it = 0;
			s_collection = arr2;
			s_collection_length1 = arr2_length1;
			for (s_it = 0; s_it < s_collection_length1; s_it = s_it + 1) {
				gchar* _tmp1_;
				gchar* s = NULL;
				_tmp1_ = g_strdup (s_collection[s_it]);
				s = _tmp1_;
				{
					const gchar* _tmp2_;
					gchar** _tmp3_;
					gint _tmp3__length1;
					_tmp2_ = s;
					_tmp3_ = res;
					_tmp3__length1 = res_length1;
					if (!_vala_string_array_contains (_tmp3_, _tmp3__length1, _tmp2_)) {
						const gchar* _tmp4_;
						gchar* _tmp5_;
						_tmp4_ = s;
						_tmp5_ = g_strdup (_tmp4_);
						_vala_array_add2 (&res, &res_length1, &_res_size_, _tmp5_);
					}
					_g_free0 (s);
				}
			}
		}
	}
	if (arr3 != NULL) {
		{
			gchar** s_collection = NULL;
			gint s_collection_length1 = 0;
			gint _s_collection_size_ = 0;
			gint s_it = 0;
			s_collection = arr3;
			s_collection_length1 = arr3_length1;
			for (s_it = 0; s_it < s_collection_length1; s_it = s_it + 1) {
				gchar* _tmp6_;
				gchar* s = NULL;
				_tmp6_ = g_strdup (s_collection[s_it]);
				s = _tmp6_;
				{
					const gchar* _tmp7_;
					gchar** _tmp8_;
					gint _tmp8__length1;
					_tmp7_ = s;
					_tmp8_ = res;
					_tmp8__length1 = res_length1;
					if (!_vala_string_array_contains (_tmp8_, _tmp8__length1, _tmp7_)) {
						const gchar* _tmp9_;
						gchar* _tmp10_;
						_tmp9_ = s;
						_tmp10_ = g_strdup (_tmp9_);
						_vala_array_add3 (&res, &res_length1, &_res_size_, _tmp10_);
					}
					_g_free0 (s);
				}
			}
		}
	}
	_tmp11_ = res;
	_tmp11__length1 = res_length1;
	if (result_length1) {
		*result_length1 = _tmp11__length1;
	}
	result = _tmp11_;
	return result;
}

GIcon*
launch_bar_bar_get_icon_from_id (LaunchBarBar* self,
                                 const gchar* id)
{
	GtkFlowBox* _tmp0_;
	GList* _tmp1_;
	GThemedIcon* _tmp11_;
	GIcon* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (id != NULL, NULL);
	_tmp0_ = self->priv->layout;
	_tmp1_ = gtk_container_get_children ((GtkContainer*) _tmp0_);
	{
		GList* ch_collection = NULL;
		GList* ch_it = NULL;
		ch_collection = _tmp1_;
		for (ch_it = ch_collection; ch_it != NULL; ch_it = ch_it->next) {
			GtkWidget* ch = NULL;
			ch = (GtkWidget*) ch_it->data;
			{
				LaunchBarButton* bt = NULL;
				GtkWidget* _tmp2_;
				LaunchBarButton* _tmp3_;
				LaunchBarButton* _tmp4_;
				const gchar* _tmp5_;
				const gchar* _tmp6_;
				_tmp2_ = ch;
				_tmp3_ = _g_object_ref0 (LAUNCH_BAR_IS_BUTTON (_tmp2_) ? ((LaunchBarButton*) _tmp2_) : NULL);
				bt = _tmp3_;
				_tmp4_ = bt;
				_tmp5_ = launch_bar_button_get_id (_tmp4_);
				_tmp6_ = _tmp5_;
				if (g_strcmp0 (_tmp6_, id) == 0) {
					LaunchBarButton* _tmp7_;
					GIcon* _tmp8_;
					GIcon* _tmp9_;
					GIcon* _tmp10_;
					_tmp7_ = bt;
					_tmp8_ = launch_bar_button_get_icon (_tmp7_);
					_tmp9_ = _tmp8_;
					_tmp10_ = _g_object_ref0 (_tmp9_);
					result = _tmp10_;
					_g_object_unref0 (bt);
					(ch_collection == NULL) ? NULL : (ch_collection = (g_list_free (ch_collection), NULL));
					return result;
				}
				_g_object_unref0 (bt);
			}
		}
		(ch_collection == NULL) ? NULL : (ch_collection = (g_list_free (ch_collection), NULL));
	}
	_tmp11_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("image-missing-symbolic");
	result = (GIcon*) _tmp11_;
	return result;
}

gchar*
launch_bar_bar_get_display_name_from_id (LaunchBarBar* self,
                                         const gchar* id)
{
	GtkFlowBox* _tmp0_;
	GList* _tmp1_;
	gchar* _tmp10_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (id != NULL, NULL);
	_tmp0_ = self->priv->layout;
	_tmp1_ = gtk_container_get_children ((GtkContainer*) _tmp0_);
	{
		GList* ch_collection = NULL;
		GList* ch_it = NULL;
		ch_collection = _tmp1_;
		for (ch_it = ch_collection; ch_it != NULL; ch_it = ch_it->next) {
			GtkWidget* ch = NULL;
			ch = (GtkWidget*) ch_it->data;
			{
				LaunchBarButton* bt = NULL;
				GtkWidget* _tmp2_;
				LaunchBarButton* _tmp3_;
				LaunchBarButton* _tmp4_;
				const gchar* _tmp5_;
				const gchar* _tmp6_;
				_tmp2_ = ch;
				_tmp3_ = _g_object_ref0 (LAUNCH_BAR_IS_BUTTON (_tmp2_) ? ((LaunchBarButton*) _tmp2_) : NULL);
				bt = _tmp3_;
				_tmp4_ = bt;
				_tmp5_ = launch_bar_button_get_id (_tmp4_);
				_tmp6_ = _tmp5_;
				if (g_strcmp0 (_tmp6_, id) == 0) {
					LaunchBarButton* _tmp7_;
					gchar* _tmp8_;
					gchar* _tmp9_;
					_tmp7_ = bt;
					_tmp8_ = launch_bar_button_get_display_name (_tmp7_);
					_tmp9_ = _tmp8_;
					result = _tmp9_;
					_g_object_unref0 (bt);
					(ch_collection == NULL) ? NULL : (ch_collection = (g_list_free (ch_collection), NULL));
					return result;
				}
				_g_object_unref0 (bt);
			}
		}
		(ch_collection == NULL) ? NULL : (ch_collection = (g_list_free (ch_collection), NULL));
	}
	_tmp10_ = g_strdup (id);
	result = _tmp10_;
	return result;
}

static void
launch_bar_bar_class_init (LaunchBarBarClass * klass,
                           gpointer klass_data)
{
	launch_bar_bar_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &LaunchBarBar_private_offset);
	((GObjectClass *) klass)->constructed = (void (*) (GObject*)) launch_bar_bar_real_constructed;
	((ValaPanelAppletClass *) klass)->get_settings_ui = (GtkWidget* (*) (ValaPanelApplet*)) launch_bar_bar_real_get_settings_ui;
	G_OBJECT_CLASS (klass)->finalize = launch_bar_bar_finalize;
}

static void
launch_bar_bar_instance_init (LaunchBarBar * self,
                              gpointer klass)
{
	self->priv = launch_bar_bar_get_instance_private (self);
}

static void
launch_bar_bar_finalize (GObject * obj)
{
	LaunchBarBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, LAUNCH_BAR_TYPE_BAR, LaunchBarBar);
	self->ids = (_vala_array_free (self->ids, self->ids_length1, (GDestroyNotify) g_free), NULL);
	_g_object_unref0 (self->priv->layout);
	self->priv->prev_ids = (_vala_array_free (self->priv->prev_ids, self->priv->prev_ids_length1, (GDestroyNotify) g_free), NULL);
	_g_object_unref0 (self->priv->app_monitor);
	G_OBJECT_CLASS (launch_bar_bar_parent_class)->finalize (obj);
}

GType
launch_bar_bar_get_type (void)
{
	return launch_bar_bar_type_id;
}

GType
launch_bar_bar_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (LaunchBarBarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) launch_bar_bar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LaunchBarBar), 0, (GInstanceInitFunc) launch_bar_bar_instance_init, NULL };
	launch_bar_bar_type_id = g_type_module_register_type (module, VALA_PANEL_TYPE_APPLET, "LaunchBarBar", &g_define_type_info, 0);
	LaunchBarBar_private_offset = sizeof (LaunchBarBarPrivate);
	return launch_bar_bar_type_id;
}

void
g_io_launchbar_load (GTypeModule* module)
{
	g_return_if_fail (module != NULL);
	launch_bar_bar_register_type (module);
	launch_bar_button_register_type (module);
	launch_bar_config_widget_register_type (module);
	g_io_extension_point_implement (VALA_PANEL_APPLET_EXTENSION_POINT, LAUNCH_BAR_TYPE_BAR, "org.valapanel.launchbar", 10);
}

void
g_io_launchbar_unload (GIOModule* module)
{
	g_return_if_fail (module != NULL);
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

